resource-website/inventory/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('', views.view_index, name='inventory'),
    path('view_category/<int:category_id>', views.view_category, name='parts_category'),
    path('view_category/<int:category_id>/page/<int:page>/<order>', views.view_category, name='parts_category_page'),
    path('view_category/<int:category_id>/locations', views.view_part_locations, name='part_locations'),
    path('part/<int:part_id>', views.view_part, name='part'),
    path('cart', views.view_cart, name='cart'),
    path('previous_orders', views.view_previous_orders, name='previous_orders'),
    path('digikey_auth', views.view_digikey_auth, name='digikey_auth'),
    path('digikey_lookup', views.view_digikey_lookup, name='digikey_lookup'),
    path('barcodes', views.view_barcodes, name='barcodes'),
    path('barcode_lookup', views.view_barcode_lookup, name='barcode_lookup'),
    path('fillorders', views.fill_orders, name='fill_orders'),
    path('fillorders/<int:order_id>', views.fill_order, name='fill_order'),
    path('submit_request', views.view_submit_request, name='submit_request'),
    path('analytics_categories', views.view_analytics_categories, name='analytics_categories'),
    path('analytics_parts', views.view_analytics_parts, name='analytics_parts'),
    path('altium_parts', views.view_altium_parts, name='altium_parts'),
]

resource-website/main/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static
from django.contrib.auth.views import logout_then_login
from markdownx import urls as markdownx

urlpatterns = [
    path('', include('pages.urls')),
    path('', include('social_django.urls', namespace='social')),
    path('logout/', logout_then_login, {'login_url': settings.LOGIN_REDIRECT_URL}, name='logout'),
    path('user_management/', include('user_management.urls')),
    path('lockout/', include('lockout.urls')),
    path('loans/', include('loans.urls')),
    path('inventory/', include('inventory.urls')),
    path('tests/', include('tests.urls')),
    path('wiki/', include('wiki.urls')),
    path('worklog/', include('worklog.urls')),
    path('printcenter/', include('printcenter.urls')),
    path('trainings/', include('trainings.urls')),
    path('admin/', admin.site.urls),
    path('markdownx/', include(markdownx))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

handler404 = 'pages.views.error_404'
handler500 = 'pages.views.error_500'
handler403 = 'pages.views.error_403'
handler400 = 'pages.views.error_400'

resource-website/inventory/models.py
from string import Formatter

from django.db import models
from django.db.models import Sum

from user_management.models import CustomUser

from .metric import *
from .fields import NaturalSortField


class Manufacturer(models.Model):
    name = models.CharField(max_length=512)
    website_url = models.URLField()

    def __str__(self):
        return "{} ({})".format(self.name, self.id)


def category_picture(category, filename):
    return 'uploads/inventory/category/{}/{}'.format(category.id, filename)


class Category(models.Model):
    name = models.CharField(max_length=512)
    parent = models.ForeignKey("Category", on_delete=models.PROTECT, null=True, blank=True)
    part_name_template = models.CharField(max_length=512, blank=True, null=True)
    image = models.ImageField(null=True, blank=True, upload_to=category_picture)

    def __str__(self):
        path = [self] + self.get_all_parentcategories()
        path.reverse()
        path = map(lambda c: c.name, path)
        return "/".join(path)

    class Meta:
        verbose_name = "category"
        verbose_name_plural = "categories"

    def get_all_subcategories(self):
        subcategories = []
        for subcategory in Category.objects.filter(parent=self):
            subcategories.append(subcategory)
            subcategories += subcategory.get_all_subcategories()

        return subcategories

    def get_all_parentcategories(self):
        parentcategories = []
        if self.parent is not None:
            parentcategories.append(self.parent)
            parentcategories += self.parent.get_all_parentcategories()
        return parentcategories

    def properties_q(self):
        q = models.Q(category=self)
        if self.parent is not None:
            q = q | self.parent.properties_q()

        return q

    def parts_q(self):
        q = models.Q(category=self)
        for subcategory in Category.objects.filter(parent=self):
            q = q | subcategory.parts_q()

        return q

    def parts_count(self):
        return sum(map(lambda c: c.part_set.count(), self.get_all_subcategories() + [self]))

    def part_locations_count(self):
        return sum(map(lambda p: p.partlocation_set.count(), Part.objects.filter(self.parts_q())))

    def parts_quantity(self):
        return sum(map(lambda p: sum(map(lambda pl: pl.quantity, p.partlocation_set.all())),
                       Part.objects.filter(self.parts_q())))

    def parts_price(self):
        return sum(map(
            lambda p: (p.nominal_price() or 0) * sum(map(
                lambda pl: pl.quantity,
                p.partlocation_set.all()
            )),
            Part.objects.filter(self.parts_q())
        ))

    def parts_ordered(self):
        return sum(map(
            lambda p: sum(map(
                lambda po: po.quantity,
                p.partorder_set.all()
            )),
            Part.objects.filter(self.parts_q())
        ))


class Supplier(models.Model):
    name = models.CharField(max_length=512)
    website_url = models.URLField()

    def __str__(self):
        return "{} ({})".format(self.name, self.id)


class Location(models.Model):
    name = models.CharField(max_length=512)
    parent = models.ForeignKey("Location", on_delete=models.PROTECT, null=True, blank=True)
    non_local = models.BooleanField(null=False)

    def __str__(self):
        path = [self] + self.parents()
        path.reverse()
        path = map(lambda l: l.name, path)
        return "/".join(path)

    def parents(self):
        parents = []
        if self.parent is not None:
            parents.append(self.parent)
            parents += self.parent.parents()
        return parents


class Property(models.Model):
    name = models.CharField(max_length=512, blank=False)
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    unit = models.CharField(max_length=16, blank=True, null=True)
    metric = models.BooleanField()

    class Meta:
        verbose_name = "property"
        verbose_name_plural = "properties"

    def __str__(self):
        return "{} - {} ({})".format(self.category.name, self.name, self.id)

    def render(self, value):
        if self.metric:
            value = render_metric(value)

        if self.unit is not None:
            value += self.unit

        return value


class PartStatus(models.TextChoices):
    ACTIVE = "ACTIVE", "Active"
    NONSTOCK = "NONSTOCK", "Non-stock"
    OBSOLETE = "OBSOLETE", "Obsolete"


class Part(models.Model):
    # If name is null, the part name template from the category should be used
    name_override = models.CharField(max_length=512, null=True, blank=True)
    manufacturer = models.ForeignKey(Manufacturer, on_delete=models.SET_NULL, null=True)
    manufacturer_part_number = models.CharField(max_length=512, null=False, blank=True)
    supplier = models.ManyToManyField(Supplier, through='PartSupplier')
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    datasheet = models.URLField(null=True, blank=True)
    description = models.TextField(null=True, blank=True)
    locations = models.ManyToManyField(Location, through='PartLocation')
    properties = models.ManyToManyField(Property, through='PartProperty')
    altium_symbol = models.CharField(max_length=512, null=True, blank=True)
    altium_footprint = models.CharField(max_length=512, null=True, blank=True)
    status = models.CharField(
        max_length=512,
        choices=PartStatus.choices,
        default=PartStatus.ACTIVE,
    )

    def __str__(self):
        return "{} ({})".format(self.name, self.id)

    class Meta:
        permissions = (
            ("use_inventory", "Can use inventory"),
            ("edit_parts", "Can edit parts"),
        )

    def part_name_template(self):
        if self.category.part_name_template is not None:
            return self.category.part_name_template
        else:
            parents = self.category.get_all_parentcategories()
            for parent in parents:
                if parent.part_name_template is not None:
                    return parent.part_name_template
            return None

    def status_label(self):
        return dict(PartStatus.choices)[self.status]

    @property
    def name(self):
        if self.name_override is not None:
            return self.name_override
        else:
            properties = PartProperty.objects.filter(part=self)
            keys = {}
            for property in properties:
                value = property.value
                if property.property.metric:
                    value = render_metric(value)
                if property.property.unit is not None:
                    keys[property.property.name] = value + property.property.unit
                else:
                    keys[property.property.name] = value

            part_name_template = self.part_name_template()

            if part_name_template is not None:
                for text, key, spec, conversion in Formatter().parse(part_name_template):
                    if key is not None and key not in keys:
                        keys[key] = "―"

                return self.part_name_template().format(**keys)
            else:
                return "―"

    @property
    def qty_available(self):
        locations = PartLocation.objects.filter(part=self)
        stock = 0
        for part_location in locations:
            stock += part_location.quantity
        return stock

    def nominal_price(self):
        part_supplier = PartSupplier.objects.filter(part=self, price__isnull=False).first()

        if part_supplier is not None:
            return part_supplier.price
        else:
            return None

    def quantity_ordered(self):
        return PartOrder.objects.filter(part=self).aggregate(Sum('quantity'))['quantity__sum'] or 0


class PartSupplier(models.Model):
    part = models.ForeignKey(Part, on_delete=models.CASCADE)
    supplier = models.ForeignKey(Supplier, on_delete=models.CASCADE)
    supplier_part_number = models.CharField(max_length=512, null=True, blank=True)
    supplier_part_url = models.URLField(blank=True, null=True)
    price = models.FloatField(blank=True, null=True)

    def __str__(self):
        return "{} - {} ({})".format(self.part.name, self.supplier.name, self.id)

    class Meta:
        permissions = (
            ("view_part_suppliers", "View Part Suppliers"),
        )


class PartProperty(models.Model):
    part = models.ForeignKey(Part, on_delete=models.CASCADE)
    property = models.ForeignKey(Property, on_delete=models.CASCADE)
    value = models.CharField(max_length=512)
    value_sort = NaturalSortField(for_field='value', max_length=512)

    class Meta:
        verbose_name = "part property"
        verbose_name_plural = "part properties"

    def __str__(self):
        return "{} - {} ({})".format(self.part.name, self.property, self.id)

    def __lt__(self, other):
        try:
            first = float(self.value)
            second = float(other.value)
            return first.__lt__(second)
        except ValueError:
            return self.value.__lt__(other)

    def rendered(self):
        return self.property.render(self.value)


class PartLocation(models.Model):
    location = models.ForeignKey(Location, on_delete=models.CASCADE)
    part = models.ForeignKey(Part, on_delete=models.CASCADE)
    quantity = models.PositiveIntegerField()
    barcode = models.CharField(max_length=512, null=True, blank=True)
    primary_location = models.BooleanField(null=False)

    def __str__(self):
        return "{} - {} ({})".format(self.part.name, self.location.name, self.id)

    class Meta:
        permissions = (
            ('generate_barcode_sheets', 'Generate barcode sheets'),
            ('lookup_barcodes', "Lookup barcodes"),
            ('view_part_locations', "View Part Locations"),
        )


class OrderStatus(models.TextChoices):
    CART = "CART", "Cart"
    SUBMITTED = "SUBMITTED", "Submitted"

resource-website/inventory/forms.py
from django import forms
from django.forms import inlineformset_factory, modelformset_factory, DateInput
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Div, ButtonHolder, Submit, HTML, Button

from pages.crispy import InputGroupLayout, DynamicFormsetHelper

from .models import *


class HomepageSearchForm(forms.Form):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.helper.layout = InputGroupLayout(
            'search',
            append=Div(ButtonHolder(
                HTML("<button type='submit' class='btn btn-primary'><i class='fas fa-search'></i></button>"),
            )),
            css_class="mb-3"
        )

    search = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control-lg'}))


class SupplierImportForm(forms.Form):
    category = forms.ModelChoiceField(Category.objects.all())
    part_numbers = forms.CharField(widget=forms.Textarea)


class PartLocationForm(forms.Form):
    part_numbers = forms.CharField(widget=forms.Textarea)

resource-website/inventory/templates/inventory/analytics_parts.html
{% extends 'inventory/base.html' %}
{% load crispy_forms_tags %}

{% block title %} | Inventory {% endblock %}

{% block content %}
    <div class="nav nav-pills nav-justified m-3">
        <div class="nav-item">
            <a class="nav-link" href="{% url 'analytics_categories' %}">Categories</a>
        </div>
        <div class="nav-item">
            <a class="nav-link active" href="{% url 'analytics_parts' %}">Parts</a>
        </div>
    </div>
    <div class="table-responsive">
        <table class="table table-sm table-striped">
            <thead class="thead-light">
            <tr>
                <th scope="col" class="text-nowrap">
                    Part
                    {% if order == 'name' %}
                        <a href="{% url 'analytics_parts' %}?order=-name">
                            <i class="fas fa-sort-up"></i>
                        </a>
                    {% elif order == '-name' %}
                        <a href="{% url 'analytics_parts' %}?order=name">
                            <i class="fas fa-sort-down"></i>
                        </a>
                    {% else %}
                        <a href="{% url 'analytics_parts' %}?order=name">
                            <i class="fas fa-sort"></i>
                        </a>
                    {% endif %}
                </th>
                <th scope="col" class="text-nowrap text-right align-middle">
                    Ordered
                    {% if order == 'ordered' %}
                        <a href="{% url 'analytics_parts' %}?order=-ordered">
                            <i class="fas fa-sort-up"></i>
                        </a>
                    {% elif order == '-ordered' %}
                        <a href="{% url 'analytics_parts' %}?order=ordered">
                            <i class="fas fa-sort-down"></i>
                        </a>
                    {% else %}
                        <a href="{% url 'analytics_parts' %}?order=ordered">
                            <i class="fas fa-sort"></i>
                        </a>
                    {% endif %}
                </th>
            </tr>
            </thead>
            <tbody>
            {% for part in parts %}
                <tr>
                    <td><a href="{% url 'part' part_id=part.id %}">{{ part.name }}</a></td>
                    <td class="text-right align-middle" style=>{{ part.quantity_ordered }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
{% endblock %}

resource-website/inventory/templates/inventory/digikey_lookup.html
{% extends 'inventory/base.html' %}
{% load crispy_forms_tags %}

{% block title %} | Inventory {% endblock %}

{% block content %}
    <h1 class="m-3 text-center">Import from Digi-Key</h1>

    <div class="container-fluid">
        <div class="row">
            <div class="col-md">
                <div class="card m-1">
                    <div class="card-header">
                        <h5>Lookup Parts</h5>
                    </div>
                    <form method="GET" class="m-3">
                        {% csrf_token %}
                        {{ form | crispy }}
                        <input type="submit" class="btn btn-primary" value="Lookup Parts"/>
                    </form>
                </div>
            </div>
            {% if parts|length > 0 %}
                <div class="col-md">
                    <div class="card m-1">
                        <div class="card-header">
                            <h5>Imported Properties</h5>
                        </div>
                        <div class="list-group list-group-flush">
                            {% for property in properties %}
                                <div class="list-group-item">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text" style="min-width: 8em">{{ property.name }}</span>
                                        </div>

                                        <select id="{{ property.id }}_type" class="custom-select" style="width: 8em;">
                                            <option value="none">None</option>
                                            <option value="constant">Constant</option>
                                            <option value="digikey">Digi-Key</option>
                                        </select>
                                        <select id="{{ property.id }}_digikey" class="custom-select" style="width: 8em;"
                                                hidden>
                                            {% for digikey_property in digikey_properties %}
                                                <option value="{{ digikey_property }}">{{ digikey_property }}</option>
                                            {% endfor %}
                                        </select>
                                        <input id="{{ property.id }}_constant" type="text" placeholder="Value"
                                               class="form-control" style="width: 8em" hidden/>
                                        <div class="input-group-append">
                                            {% if property.unit == None %}
                                                <span class="input-group-text"></span>
                                            {% else %}
                                                <span class="input-group-text">{{ property.unit }}</span>
                                            {% endif %}
                                        </div>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            {% endif %}
        </div>
    </div>

    {% if parts|length > 0 %}
        <div class="table-responsive mt-3">
            <table class="table table-hover">
                <thead class="thead-light">
                <tr>
                    <th class="text-wrap"><i class="fas fa-file"></i></th>
                    <th class="text-wrap">Mfg. Part #</th>
                    <th class="text-wrap text-right">Mfg.</th>
                    <th class="text-wrap text-right">Digi-Key Part #</th>
                    <th class="text-wrap text-right">Description</th>
                    <th class="text-wrap text-right">Cost</th>
                    {% for property in properties %}
                        <th class="text-right">{{ property.name }}</th>
                    {% endfor %}
                </tr>
                </thead>
                <tbody>
                {% for part in parts %}
                    {% with id=forloop.counter0 %}
                        <tr class="{% if part.existing_part != None %} table-warning {% else %} table-success {% endif %}">
                            <td id="{{ id }}_datasheet" class="text-right align-middle">
                                <a href="{{ part.datasheet }}"><i class="fas fa-file"></i></a>
                            </td>
                            <td id="{{ id }}_manufacturer_part_number" class="align-middle">{{ part.manufacturer_part_number }}</td>
                            <td id="{{ id }}_manufacturer" class="text-right align-middle">{{ part.manufacturer }}</td>
                            <td id="{{ id }}_digikey_part_number" class="text-right align-middle">
                                <a href="{{ part.digikey_url }}">
                                    {{ part.digikey_part_number }}
                                </a>
                            </td>
                            <td id="{{ id }}_description" class="text-right align-middle">{{ part.description }}</td>
                            <td id="{{ id }}_price" class="text-right align-middle">${{ part.price }}</td>
                            {% for property in properties %}
                                <td id="{{ id }}_{{ property.id }}" class="text-right align-middle"></td>
                            {% endfor %}
                        </tr>
                    {% endwith %}
                {% endfor %}
                </tbody>
            </table>
        </div>

        <form method="post">
            {% csrf_token %}
            <input id="category" name="category" value="" type="hidden"/>
            <input id="data" name="data" value="" type="hidden"/>
            <input type="submit" class="btn btn-primary" value="Import Parts"/>
        </form>
    {% else %}
        <p class="text-center mt-3">No parts found</p>
    {% endif %}

    <script>

        let generate_parts = function () {

            let parts = [];

            let part_property = function (id, metric, digikey_properties) {
                let type_select = document.getElementById(id + "_type");
                let digikey_select = document.getElementById(id + "_digikey");
                let constant_field = document.getElementById(id + "_constant");

                let selected = type_select.value;

                if (selected === "none") {
                    return null;
                } else if (selected === "digikey") {
                    let digikey_property = digikey_properties[digikey_select.value];
                    if (digikey_property !== null && digikey_property !== undefined) {
                        if (metric) {
                            return digikey_property['metric'];
                        } else {
                            return digikey_property['raw'];
                        }
                    } else {
                        return null
                    }
                } else if (selected === "constant") {
                    return constant_field.value;
                } else {
                    return "??";
                }
            }

            {% for part in parts %} {
                let digikey_properties = {
                    {% for name, metric_value, raw_value in part.properties %}
                        {% autoescape off %}
                            "{{ name }}": {"metric": "{{ metric_value }}", "raw": '{{ raw_value }}'},
                        {% endautoescape %}
                    {% endfor %}
                };

                let properties = {
                    {% for property in properties %}
                        "{{ property.id }}": part_property("{{ property.id }}", {{ property.metric | lower }}, digikey_properties),
                    {% endfor %}
                };

                let existing_properties = {
                    {% if part.existing_part != None %}
                        {% for part_property in part.existing_part.partproperty_set.all %}
                            "{{ part_property.property.id }}": "{{ part_property.rendered }}",
                        {% endfor %}
                    {% endif %}
                };

                console.log(existing_properties)

                let part = {
                    "manufacturer": "{{ part.manufacturer }}",
                    "manufacturer_part_number": "{{ part.manufacturer_part_number }}",
                    "digikey_part_number": "{{ part.digikey_part_number }}",
                    "digikey_url": "{{ part.digikey_url }}",
                    "datasheet": "{{ part.datasheet }}",
                    "description": "{{ part.description }}",
                    "price": "{{ part.price }}",
                    "digikey_properties": digikey_properties,
                    "properties": properties,
                    "existing_properties": existing_properties,
                }
                parts.push(part);
            } {% endfor %}

            return parts;
        };

        let update_table = function (parts) {
            {% for part in parts %} {
                {% with id=forloop.counter0 %}
                    let part = parts[{{ id }}];
                    let properties = part['properties']
                    let existing_properties = part['existing_properties']
                    console.log(existing_properties)
                    {% for property in properties %} {
                        let property = properties["{{ property.id }}"];
                        let existing_property = existing_properties["{{ property.id }}"]
                        console.log("{{ property.id }}: " + existing_property);
                        let cell = document.getElementById("{{ id }}_{{ property.id }}")
                        if (property !== undefined && property !== null) {
                            cell.classList.add('border')
                            cell.classList.add('border-success');
                            cell.classList.remove('text-success');
                            {% if property.unit == None %}
                                cell.innerText = property;
                            {% else %}
                                cell.innerText = property + "{{ property.unit }}";
                            {% endif %}
                        } else if (existing_property !== undefined && existing_property !== null) {
                            cell.classList.remove('border')
                            cell.classList.remove('border-success');
                            cell.classList.remove('text-success');
                            cell.innerText = existing_property;
                        } else {
                            cell.classList.remove('border')
                            cell.classList.remove('border-success');
                            cell.classList.add('text-success');
                            cell.innerText = "―";
                        }
                    } {% endfor %}
                {% endwith %}
            } {% endfor %}
        };

        property_type_select_onchange = function (id) {
            return function () {
                let type_select = document.getElementById(id + "_type");
                let digikey_select = document.getElementById(id + "_digikey");
                let constant_field = document.getElementById(id + "_constant");

                let selected = type_select.value;

                if (selected === "none") {
                    digikey_select.hidden = true;
                    constant_field.hidden = true;
                } else if (selected === "digikey") {
                    digikey_select.hidden = false;
                    constant_field.hidden = true;
                } else if (selected === "constant") {
                    digikey_select.hidden = true;
                    constant_field.hidden = false;
                }
            };
        }

        let onupdate = function () {
            let parts = generate_parts();
            update_table(parts);
            document.getElementById("data").value = JSON.stringify(parts)
            document.getElementById("category").value = document.getElementById('id_category').value
        }

        {% for property in properties %}
            document.getElementById("{{ property.id }}_type").onchange = function () {
                property_type_select_onchange("{{ property.id }}")();
                onupdate();
            };

            document.getElementById("{{ property.id }}_digikey").onchange = onupdate;

            document.getElementById("{{ property.id }}_constant").oninput = onupdate;

            property_type_select_onchange("{{ property.id }}")();
        {% endfor %}

        onupdate();
    </script>
{% endblock %}

resource-website/inventory/templates/inventory/lookup_barcodes.html
{% extends 'inventory/base.html' %}
{% load crispy_forms_tags %}

{% block title %} | Inventory {% endblock %}

{% block content %}
    <div class="container">
        <h1 class="m-3 text-center">Barcode Lookup</h1>
        <h2 class="m-3 text-center">{{ barcode }}</h2>

        <div class="list-group">
            {% if part_locations|length > 1 %}
                <div class="text-center alert alert-danger">
                    There are more than one part location with this barcode. This should not be the case.
                </div>
            {% endif %}
            {% for part_location in part_locations %}
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">
                    <div class="d-flex flex-row align-items-center">
                        <h5 class="my-0">
                            <a href="{% url 'part' part_id=part_location.part.id %}">
                                {{ part_location.part.name }}
                            </a>
                        </h5>
                        {% if part_location.primary_location %}
                            <span class="badge badge-primary mx-3">primary</span>
                        {% endif %}
                    </div>
                    <span>{{ part_location.location }}</span>
                </div>
            {% endfor %}
        </div>


    </div>
{% endblock %}

resource-website/inventory/templates/inventory/part_order_details.html
<table class="table mt-3">
    <thead>
    <tr>
        <th scope="col">Part Name</th>
        <th scope="col">IPN</th>
        <th scope="col">MPN</th>
        <th scope="col">Quantity</th>

    </tr>
    </thead>
    <tbody>
    {% for part_order in part_orders %}
        <tr>
            <td><a href="{% url 'part' part_id=part_order.part.id %}">{{ part_order.part.name }}</a></td>
            <td>{{ part_order.part.id }}</td>
            <td>{{ part_order.part.manufacturer_part_number }}</td>
            <td>{{ part_order.quantity }}</td>


        </tr>
    {% endfor %}
    </tbody>
</table>